#!/bin/bash

###
### Центр Обновления
###
### Copyright (C) ООО Кейсистемс 2020
###


# === Определяем каталог выполнения текущего скрипта ==================================
dks_bashfile_dir="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
ks_inst_path="/opt"
# Файл списка софтов
ks_list_file="${dks_bashfile_dir}/ks_list.json"
dks_folders_file="${dks_bashfile_dir}/dks_folders"
rm -f ${ks_list_file}
touch ${ks_list_file}
localip="$(echo $(ip -h address show | grep "inet " | grep -v "docker" | grep -v "podman" | grep -v "host lo" | awk '{print $2}' | head -n1 | cut -d '/' -f 1))"
instapp=($(which apt 2>/dev/null | sed 's/.*\///' 2>/dev/null))
if [ "$instapp" = "" ];then
	instapp=($(which yum 2>/dev/null | sed 's/.*\///' 2>/dev/null))
fi

cat << EOF >> ${ks_list_file}
[
EOF



function fn_get_lvl_01() {
local ks_list_file=$1
local comma=$2
local inifile=$3

local dir=$(dirname ${inifile})
local name=$(basename ${dir})
local isdks=${name:0:4}
local type
#local type=$(echo ${name} | rev | cut -d"-" -f2- | rev | sed 's/.*-//')
if [ "${isdks}" = "dks-" ];then
	type=$(echo ${name:4} | sed 's/-.*//')
else
	type=$(echo ${name} | sed 's/-.*//')
fi;
local inidata="{}"
if [ -f "${inifile}" ];then
	#name=$(iconv -f WINDOWS-1251 -t UTF-8 ${inifile} | grep -oP '"name"\s*:\s*"\K.*?(?=")' | head -1)
	#dir=$(iconv -f WINDOWS-1251 -t UTF-8 ${inifile} | grep -oP '"rootdir"\s*:\s*"\K.*?(?=")' | head -1)
	#type=$(iconv -f WINDOWS-1251 -t UTF-8 ${inifile} | grep -oP '"type"\s*:\s*"\K.*?(?=")' | head -1)
	#servicedir=$(iconv -f WINDOWS-1251 -t UTF-8 ${inifile} | grep -oP '"servicedir"\s*:\s*"\K.*?(?=")' | head -1)
	inidata=$(iconv -f WINDOWS-1251 -t UTF-8 ${inifile})
fi;
local version=$(echo ${dir} | sed 's/.*-//')

local is_exists="0"
local is_install="0"
local whichmanager=""
local dksversion=""
local eqversions="0"
#Докер
if [ "${type}" = "docker" ];then
	whichmanager=$(which docker 2>/dev/null)
	if [ "${whichmanager}" != "" ];then
		realversion=($(docker -v | sed 's/.*version //' | sed 's/,.*//'))
		if [ "${version}" = "${realversion}" ];then
			is_install="1"
			eqversions="1"
		fi;
	fi;
fi;

#Подман
if [ "${type}" = "podman" ];then
	whichmanager=$(which podman 2>/dev/null)
	if [ "${whichmanager}" != "" ];then
		version=($(podman -v | sed 's/.*version //' | sed 's/,.*//'))
		is_install="1"
	fi;
fi;

repository=""
if [ "${type}" = "docker" ] || [ "${type}" = "podman" ];then
	#Установлен из репозитория или нет
	if [ "${instapp}" = "yum" ];then
		repository=$(yum list installed 2>/dev/null | grep ${type})
	else
		repository=$(apt list --installed 2>/dev/null | grep ${type})
	fi;
fi;

if [ "${repository}" = "" ];then
	repository="0"
else
	repository="1"
fi;

if [ -d "${dir}" ];then
  is_exists="1"

  #СУБД-КС
  if [ "${type}" = "pgsqlks" ];then
    is_install="1"
  fi;

  #WEB-Сервер-КС
  if [ "${type}" = "wsks" ];then
    is_install="1"
  fi;

  #NoSqlKS
  if [ "${type}" = "nosqlks" ];then
    is_install="1"
  fi;

  #PGBOUNCER
  if [ "${type}" = "pgbouncer" ];then
    is_install="1"
  fi;

  #RMQ-КС Докер
  if [ "${type}" = "rmqks" ];then
    is_install="1"
  fi;
  
  #Трассировка
  if [ "${type}" = "jaeger" ];then
    is_install="1"
  fi;
   
  #КС Планировщик   #RMS-КС  #Агент Администрирования-КС  #АгентСЛ-КС
  if [ "${type}" = "schks" ] || [ "${type}" = "rmsks" ] || [ "${type}" = "saaks" ] || [ "${type}" = "slaks" ];then
  	alist=($(ls /opt/$type-$version | grep ${type}_[1-9]))
    alen=${#alist[*]}
    if [ ${alen} -gt 0 ];then
       is_install="1"
    fi;
  fi;

  if [ -f ${dir}/sh/dks_version ];then
    dksversion=$(sed -n 1,1p ${dir}/sh/dks_version)
	debianversion=$(echo "${dksversion}" | grep -ob '(.*)' | awk '{print tolower($0)}' | sed 's/.*(//' | sed 's/).*//')
	if [ "${debianversion}" != "" ];then
      servicedir=${name}_${debianversion}
    fi;
  fi;
fi;

# пишем первый уровень дерева
cat << EOF >> ${ks_list_file}
{
 "name" : "${name}",
 "version": "${version}",
 "dksversion": "${dksversion}",
 "type" : "${type}",
 "alen" : "${alen}",
 "is_exists" : "${is_exists}",
 "is_install" : "${is_install}",
 "rootdir" : "${dir}",
 "controldir" : "${dir}",
 "servicedir" : "${servicedir}",
 "localip" : "${localip}",
 "ini" : ${inidata},
 "instapp" : "${instapp}",
 "repository" : "${repository}",
 "nodes" : [
EOF

local ks_inst_path_dks=$ks_inst_path/dks-
local offset=$(echo ${#ks_inst_path_dks})
local dksless=${dir:$offset}

# пишем второй  уровень дерева
if [ "${type}" = "docker" ] 2> /dev/null && [ "${eqversions}" = "1" ];then
  #Имя
  dockername="Docker-CE"
  if [ "${repository}" = "1" ];then
    dockername="${dockername} (репозиторий)"
  fi;
  fn_get_lvl_02 ${ks_list_file} ${type} "${dir}" "${whichmanager}" "docker$" "${dockername}" ${version} file
fi;

if [ "${type}" = "podman" ];then
  podmanname="Podman"
  if [ "${repository}" = "1" ];then
    podmanname="${podmanname} (репозиторий)"
  fi;
  fn_get_lvl_02 ${ks_list_file} ${type} "${dir}" "${whichmanager}" "podman" "${podmanname}" ${version} file
fi;

#СУБД-КС
if [ "${type}" = "pgsqlks" ];then
  fn_get_lvl_02 ${ks_list_file} ${type} "${dir}" "/var/lib" ${dksless}"_[1-9]" "СУБД-КС" ${version} dir
fi;

#Трассировка
if [ "${type}" = "jaeger" ];then
  fn_get_lvl_02 ${ks_list_file} ${type} "${dir}" "/opt" ${dksless}"_[1-9]" "Система распределённой трассировки" ${version} dir
fi;

#WEB-Сервер-КС
if [ "${type}" = "wsks" ];then
  fn_get_lvl_02 ${ks_list_file} ${type} "${dir}" "/opt" ${dksless}"_[0-9]" "WEB-Сервер-КС" ${version} dir
fi;

#nosqlks
if [ "${type}" = "nosqlks" ];then
  fn_get_lvl_02 ${ks_list_file} ${type} "${dir}" "/var/lib" ${dksless}"_[0-9]" "NoSQL-КС" ${version} dir
fi;

#PGBOUNCER
if [ "${type}" = "pgbouncer" ];then
  fn_get_lvl_02 ${ks_list_file} ${type} "${dir}" "/opt" ${dksless}"_[1-9]" "PgBouncer" ${version} dir
fi;

#АгентСЛ-КС
if [ "${type}" = "slaks" ] 2> /dev/null && [ "${is_install}" = "1" ];then
  fn_get_lvl_02 ${ks_list_file} ${type} "${dir}" "/opt/" ${type}-${version} "Агент лицензирования (основа)" ${version} dir
fi

#Агент Администрирования-КС
if [ "${type}" = "saaks" ] 2> /dev/null && [ "${is_install}" = "1" ];then
  fn_get_lvl_02 ${ks_list_file} ${type} "${dir}" "/opt/" ${type}-${version} "Агент администрирования (основа)" ${version} dir
fi

#КС Планировщик
if [ "${type}" = "schks" ] 2> /dev/null && [ "${is_install}" = "1" ];then
  fn_get_lvl_02 ${ks_list_file} ${type} "${dir}" "/opt/" ${type}-${version} "КС Планировщик (основа)" ${version} dir
fi

#RMS-КС
if [ "${type}" = "rmsks" ] 2> /dev/null && [ "${is_install}" = "1" ];then
  fn_get_lvl_02 ${ks_list_file} ${type} "${dir}" "/opt/" ${type}-${version} "Интеграция-КС (основа)" ${version} dir
fi;

#RMQ-КС
if [ "${type}" = "rmqks" ];then
  fn_get_lvl_02 ${ks_list_file} ${type} "${dir}" "/opt" ${dksless}"_[1-9]" "RMQ-КС" ${version} dir
fi;

cat << EOF >> ${ks_list_file}
  ]
}${comma}
EOF

}

function fn_get_lvl_02() {
local ks_list_file=$1
local type=$2
local controldir=$3
local search_path=$4
local serach_template=$5
local title=$6
local version=$7
local search_type=$8

local is_running="0"
local service
local socket
local alist
local item
local port
local installdir
local comma
local index
local alen
local rootdir="${controldir}"
local manager
local serverip=""
local serverport=""
local titlename="$title"
local wstype=""
if [ "$search_type" = "dir" ];then
	alist=($(ls -d ${search_path}/*/ | grep "${serach_template}" | sed 's/\/$//'))
else
	if [ "$search_path" != "" ];then
		search_path=$(dirname $search_path)
		alist=($(ls ${search_path} | grep "${serach_template}"))
	fi;
fi;
alen=${#alist[*]}

if [ "${alen}" = "0" ];then
  return 0;
fi;

alen=$((${alen}-1))

for index in ${!alist[*]}
do
  manager="docker"
  titlename="$title"

  item=($(basename ${alist[${index}]}))
  port=$(echo ${item} | sed 's|.*_||')
  tagname=$(echo ${item} | sed -r 's/_.+//')
  installdir="${search_path}/${item}"

  if [ -f ${installdir}/podman ];then
	manager="podman"
  fi;

  if [ "${type}" = "docker" ];then
    service="docker.service"
	socket="$service"
    installdir="${search_path}"
    port=""
	manager="$type"
  fi;

  if [ "${type}" = "podman" ];then
    service="podman.service"
	socket="podman.socket"
    installdir="${search_path}"
    port=""
	manager="$type"
  fi;

  if [ "${type}" = "pgsqlks" ];then
    service="${item}.service"
	socket="$service"
	serverip="$(echo $(ip -h address show | grep "inet " | grep -v "docker" | grep -v "podman" | grep -v "host lo" | awk '{print $2}' | head -n1 | cut -d '/' -f 1))"
  fi;

  aspnetcore="Production"
  
  if [ "${type}" = "wsks" ];then
    service="${tagname}_${port}.service"
	socket="$service"
    controldir="${installdir}/ctl"
	serverip="$(echo $(ip -h address show | grep "inet " | grep -v "docker" | grep -v "podman" | grep -v "host lo" | awk '{print $2}' | head -n1 | cut -d '/' -f 1))"
	wstype="$(${controldir}/ws_const_var.sh ws_type)"
	if [ -f ${installdir}/staging ];then
		aspnetcore="Staging"
	fi;
  fi;

  if [ "${type}" = "nosqlks" ];then
    service="${tagname}_${port}.service"
	socket="$service"
    controldir="/opt/${item}/ctl"
  fi;

  if [ "${type}" = "pgbouncer" ];then
    service="${tagname}_${port}.service"
	socket="$service"
	controldir="${installdir}/ctl"
	serverip=$(cat ${installdir}/conf.d/pgbouncer_db.ini | grep -oP 'host\s*=\s*\K.*?(?=(\s|$))')
	serverport=$(cat ${installdir}/conf.d/pgbouncer_db.ini | grep -oP 'port\s*=\s*\K.*?(?=(\s|$))')
  fi;
  
  if [ "${type}" = "rmqks" ];then
    service="${tagname}_${port}.service"
	socket="$service"
  fi;

  if [ "${type}" = "jaeger" ];then
    service="${tagname}_${port}.service"
	socket="$service"
  fi;

  if [ "$port" != "" ];then
	titlename="${titlename}"
  fi;

  if [ "${type}" = "schks" ] || [ "${type}" = "rmsks" ] || [ "${type}" = "saaks" ] || [ "${type}" = "slaks" ];then
    service=""
	socket=""
	port=""
	is_running=""
  else
    service_inst=$(service_exists ${service})
    is_running=$(echo $(systemctl is-active ${socket}))
    if [ "${is_running}" = "active" ];then
      is_running="1"
    else
      is_running="0"
    fi;
  fi;

  if [ -f ${installdir}/dks_version ];then
    dksversion=$(sed -n 1,1p ${installdir}/dks_version)
  fi;

  comment=$(cat ${installdir}/comment.txt 2>/dev/null | base64)

  if [ "${index}" = "${alen}" ];then
    comma=""
  else
    comma=","
  fi;

cat << EOF >> ${ks_list_file}
             {
              "name" : "${titlename}",
              "version": "${version}",
              "dksversion": "${dksversion}",
              "type" : "${type}",
              "wstype" : "${wstype}",
              "port" : "${port}",
              "rootdir" : "${rootdir}",
              "installdir" : "${installdir}",
              "controldir" : "${controldir}",
              "service" : "${service}",
              "socket" : "${socket}",
              "service_inst" : "${service_inst}",
              "is_running" : "${is_running}",
              "serverip" : "${serverip}",
              "serverport" : "${serverport}",
              "manager" : "${manager}",
			  "comment" : "${comment}",
			  "aspnetcore" : "${aspnetcore}",
              "nodes" : [
EOF

  if [ "${type}" = "wsks" ];then
    fn_get_lvl_03 ${ks_list_file} ${type} "${installdir}" "${installdir}/www/html" ${type}"_[1-9]" "Приложение" ${version} ${serverip}":"${port} ${aspnetcore}
  fi;

  if [ "${type}" = "schks" ] || [ "${type}" = "rmsks" ] || [ "${type}" = "saaks" ] || [ "${type}" = "slaks" ];then
    fn_get_lvl_03 ${ks_list_file} ${type} "${installdir}" "${installdir}"  ${type}"_[1-9]" "Приложение" ${version} ${serverip}":"${port} ${aspnetcore}
  fi;

cat << EOF >> ${ks_list_file}
                        ]
             }${comma}
EOF

done
}

function fn_get_lvl_03(){
local ks_list_file=$1
local type=$2
local controldir=$3/ctl
local tardir=${controldir}/tar_files
local search_path=$4
local serach_template=$5
local title=$6
local pversion=$7
local pip=$8
local paspnetcore=$9

local alist
local item
local dir
local port
local comma
local index
local alen
local apptype
local archive
local archivehash
local virt_catalog
local configuration
local appversion
local sappversion
local note
local lapptype
local rootdir
local is_running="0"
local typename
alist=($(ls ${search_path} | grep "${serach_template}"))

alen=${#alist[*]}

if [ "${alen}" = "0" ];then
  return 0;
fi;

alen=$(($alen-1))

for index in ${!alist[*]}
do
  item=${alist[${index}]}
  dir=${item}
  port=$(echo ${item} | sed 's|.*_||')
  if [ "${type}" = "wsks" ] || [ "${type}" = "schks" ] || [ "${type}" = "rmsks" ] || [ "${type}" = "saaks" ] || [ "${type}" = "slaks" ];then
    if [ -f ${search_path}/${item}/wskstype ];then
      apptype=$(param_val type ${search_path}/${item}/wskstype)
	  archive=$(param_val archive ${search_path}/${item}/wskstype)
	  virt_catalog=$(param_val virt_catalog ${search_path}/${item}/wskstype)
	  #virt_catalog="<a href=\\\"https://"${pip}"/"${virt_catalog}"\\\" style=\\\"color: #1e3e73\\\">"${virt_catalog}"</a>"
	  note=$(param_val note ${search_path}/${item}/wskstype)
	  appversion=$(param_val version ${search_path}/${item}/wskstype)
	  typename=$(param_val type_name ${search_path}/${item}/wskstype)
	  if [ "${appversion}" = "" ];then
		appversion="${pversion}"
	  fi;
	  lapptype=$(echo ${apptype} | tr '[:upper:]' '[:lower:]')
	  if [ "${typename}" = "" ]; then
		title=$(fn_get_wsks_type ${apptype})
	  else
		title=${typename}
	  fi;
	  archivehash=$(param_val archivehash ${search_path}/${item}/wskstype)
	  configuration=$(param_val configuration ${search_path}/${item}/wskstype)
    else
      apptype="неизвестно"
    fi;
	sappversion=$(echo ${appversion} | cut -d '.' -f 1,2)
	rootdir="$ks_inst_path/dks-app-download/${type}-$pversion/$lapptype-$sappversion"
	
	if [ "${type}" = "wsks" ];then
	  is_running=$(echo $(ps -aux | grep "dotnet /var/www/html/${type}_${port}" | grep -v "grep"))
	fi;
    if [ "${type}" = "schks" ] || [ "${type}" = "rmsks" ] || [ "${type}" = "saaks" ] || [ "${type}" = "slaks" ];then
	  is_running=$(echo $(ps -aux | grep "dotnet /opt/${type}-${pversion}/${type}_${port}" | grep -v "grep"))
	  apptype=${type}"a"
    fi;
	
	if [ "${is_running}" != "" ];then
		is_running="1"
	else
		is_running="0"
	fi;
  fi;
  
  installdir="${search_path}/${item}"
  comment=$(cat ${installdir}/comment.txt 2>/dev/null | base64)

  if [ "${index}" = "${alen}" ];then
    comma=""
  else
    comma=","
  fi;

  
cat << EOF >> ${ks_list_file}
                         {
                          "name" : "${title}",
						  "type" : "${apptype}",
						  "version" : "${sappversion}",
						  "dksversion" : "${appversion}",
                          "port" : "${port}",
                          "rootdir" : "${rootdir}",
						  "archive" : "${archive}",
						  "archivehash" : "${archivehash}",
						  "virt_catalog" : "${virt_catalog}",
						  "note" : "${note}",
						  "configuration" : "${configuration}",
                          "installdir" : "${installdir}",
                          "controldir" : "${controldir}",
						  "is_running" : "${is_running}",
						  "comment" : "${comment}",
						  "parent_ip" : "${pip}",
						  "aspnetcore" : "${paspnetcore}"
                         }${comma}
EOF
done
}

function fn_get_wsks_type(){
local retval
case $1 in
        wBKS)
          retval="Бюджет-NEXT"
          ;;
        sBKS)
          retval="Бюджет-Смарт"
          ;;
        sSiUp)
          retval="Сервис ОД и ЭЦП"
          ;;
        sUPDS)
          retval="Сервис Обновлений"
          ;;
        wSVOD)
          retval="Свод-Смарт(web)"
          ;;
        sSVOD)
          retval="Свод-Смарт"
          ;;
        wSA)
          retval="Сервис Авторизации"
          ;;
        wRVZ)
          retval="Ревизор-Смарт(web)"
          ;;
        sRVZ)
          retval="Ревизор-Смарт"
          ;;
        wDWH)
          retval="Проект-Веб ПРО"
          ;;
        sDWH)
          retval="Проект-Смарт ПРО"
          ;;
        wADM)
          retval="Администратор-Смарт(web)"
          ;;
        sADM)
          retval="Администратор-Смарт"
          ;;
        sSMT)
          retval="Смета-Смарт"
          ;;
        wSWrk)
          retval="Сервис Воркеров"
          ;;
        wSBck)
          retval="Сервис Резервного копирования"
          ;;
        wLs)
          retval="Сервис лицензирования"
          ;;
        wCs)
          retval="Сервис конфигураций"
          ;;
        sID)
          retval="Сервис-ID"
          ;;
        wIDA)
          retval="Сервис-ID Admin"
          ;;
		sMSS)
		  retval="Собственность-СМАРТ"
		  ;;
        wMSS)
          retval="Собственность-WEB"
          ;;	  
        wBZ)
          retval="Сервис Багзилла"
          ;;	 
        wAC)
          retval="КС Сервис Администрирования"
          ;;
        wIDM)
          retval="КС IDM"
          ;;
        wDESK)
          retval="КС-Деск"
          ;;
        SCHKSa)
          retval="КС Планировщик(приложение)"
          ;;
        sLAKSa)
          retval="Агент лицензирования(приложение)"
          ;;
        sAAKSa)
          retval="Агент администрирования(приложение)"
          ;;
        RMSKSa)
          retval="Интеграция-КС(приложение)"
          ;;	
        *)
          retval="неизвестно"
          ;;
esac
echo "${retval}"
}

function param_val {
    sed -n "s/${1}=//p" $2 2> /dev/null
}

function service_exists() {
    local n=$1
	local retval
    if [[ $(systemctl list-units --all -t service --full --no-pager --no-legend "$n" ) == *$n* ]];then
        retval=1
    else
        retval=0
    fi
	echo "${retval}"
}


find ${ks_inst_path} -maxdepth 1 -type d -not -path "/opt/dks-app-download" -name "slaks-*"  2>&1> ${dks_folders_file} | { grep -v 'find:' >&2; [ $? -eq 1 ]; }
find ${ks_inst_path} -maxdepth 1 -type d -not -path "/opt/dks-app-download" -name "saaks-*"  2>&1>> ${dks_folders_file} | { grep -v 'find:' >&2; [ $? -eq 1 ]; }
find ${ks_inst_path} -maxdepth 1 -type d -not -path "/opt/dks-app-download" -name "schks-*"  2>&1>> ${dks_folders_file} | { grep -v 'find:' >&2; [ $? -eq 1 ]; }
find ${ks_inst_path} -maxdepth 1 -type d -not -path "/opt/dks-app-download" -name "rmsks-*"  2>&1>> ${dks_folders_file} | { grep -v 'find:' >&2; [ $? -eq 1 ]; }
find ${ks_inst_path} -maxdepth 1 -type d -not -path "/opt/dks-app-download" -name "tshks-*"  2>&1>> ${dks_folders_file} | { grep -v 'find:' >&2; [ $? -eq 1 ]; }
find ${ks_inst_path} -maxdepth 1 -type d -not -path "/opt/dks-app-download" -name 'dks-*' 2>&1>> ${dks_folders_file} | { grep -v 'find:' >&2; [ $? -eq 1 ]; }
find ${ks_inst_path}/dks-app-download -maxdepth 2 -type d -path "/opt/dks-app-download/wsks-*/*" 2>&1>> ${dks_folders_file} | { grep -v 'find:' >&2; [ $? -eq 1 ]; }
find ${ks_inst_path}/dks-app-download -maxdepth 2 -type d -path "/opt/dks-app-download/schks-*/*" 2>&1>> ${dks_folders_file} | { grep -v 'find:' >&2; [ $? -eq 1 ]; }
find ${ks_inst_path}/dks-app-download -maxdepth 2 -type d -path "/opt/dks-app-download/saaks-*/*" 2>&1>> ${dks_folders_file} | { grep -v 'find:' >&2; [ $? -eq 1 ]; }
find ${ks_inst_path}/dks-app-download -maxdepth 2 -type d -path "/opt/dks-app-download/slaks-*/*" 2>&1>> ${dks_folders_file} | { grep -v 'find:' >&2; [ $? -eq 1 ]; }
find ${ks_inst_path}/dks-app-download -maxdepth 2 -type d -path "/opt/dks-app-download/rmsks-*/*" 2>&1>> ${dks_folders_file} | { grep -v 'find:' >&2; [ $? -eq 1 ]; }
declare -a dockers
dockerinstalled=0
dockers=($(cat ${dks_folders_file} | grep dks-docker))
docker_exist=$(service_exists docker.service)
if [[ $docker_exist -eq 1 ]];then
	version=($(docker -v | sed 's/.*version //' | sed 's/,.*//'))
	dockerdir="/opt/dks-docker-ce-"$version
	for i in "${dockers[@]}"; do
		if [[ $i = $dockerdir ]];then
			dockerinstalled=1
		fi
	done
	if [[ $dockerinstalled -eq 0 ]];then
		echo /opt/dks-docker-ce-$version >> ${dks_folders_file}
	fi
fi

podmans=($(cat ${dks_folders_file} | grep dks-podman))

podman_exist=$(service_exists podman.service)
if [[ $podman_exist -eq 1 ]];then
	podmandir="/opt/dks-podman"
	for i in "${podmans[@]}"; do
		if [[ $i = $podmandir ]];then
			podmaninstalled=1
		fi;
	done
	if [[ $podmaninstalled -eq 0 ]];then
		echo /opt/dks-podman >> ${dks_folders_file}
	fi;
fi;
			  
#declare -a podmans
#podmans=($(cat ${dks_folders_file} | grep dks-podman))
#pcount=$(( ${#podmans[*]} ))
#if [[ $pcount -eq 0 ]]
#then
#	podman_exist=$(service_exists podman.service)
#	if [[ $podman_exist -eq 1 ]]
#	then
#		version=($(podman -v | sed 's/.*version //' | sed 's/,.*//'))
#		echo /opt/dks-podman-$version >> ${dks_folders_file}
#	fi
#fi


declare -a files
files=($(cat ${dks_folders_file}))
fcount=$(( ${#files[*]} ))
if [[ $fcount -gt 0 ]];then
	lastfile=${files[$fcount - 1]}
	for file in "${files[@]}"; do
		if [[ $file = $lastfile ]];then
			fn_get_lvl_01 ${ks_list_file}  "" "${file}/setupsrv.ini"
		else
			fn_get_lvl_01 ${ks_list_file}  "," "${file}/setupsrv.ini"
		fi;
	done
fi;
cat << EOF >> ${ks_list_file}
]
EOF


cat ${ks_list_file}
rm -f ${ks_list_file}

exit;





